APP           = xb
WINVER        = 4.0
APPVER        = 4.0

!include	<win32.mak>

CC            = cl
LIBDIR        = lib
SPASM         = spasm
OBJS          = $(LIBDIR)\xlib.o xexcept.obj xst.o xin.o xma.o xcm.o xdis.o xit.o xcow.o xgr.o xui.o $(LIBDIR)\xzzz.o
RESOURCES     = xb.rbj
START         = START /W

all:            $(APP).dll

$(APP).exe:     win32.mak $(APP).mak $(LIBDIR)\xstart.o xbasic.o $(APP).lib $(OBJS) $(RESOURCES) xb.rc
                $(link) $(guiflags) -debug:partial -debugtype:coff -subsystem:windows,$(WINVER) -version:$(APPVER) -out:$(APP).exe $(LIBDIR)\xstart.o xbasic.o $(RESOURCES) $(APP).lib $(guilibsdll)

$(APP).lib:     win32.mak $(APP).mak $(APP).def $(OBJS)
                $(implib) -machine:$(CPU) -def:$(APP).def -out:$(APP).lib $(OBJS)

$(APP).dll:     win32.mak $(APP).mak $(APP).exe $(APP).def $(APP).lib $(OBJS) $(RESOURCES) xb.rc
                $(link) -dll -debug:partial -debugtype:coff -entry:_DllMainCRTStartup$(DLLENTRY) -subsystem:windows,$(WINVER) -version:$(APPVER) -out:$(APP).dll $(OBJS) $(RESOURCES) $(APP).exp $(guilibsdll) wsock32.lib
                copy $(APP).dll $(APP).dup

xb.rbj:         xb.rc
                rc -i \xb -i \xb\xxx -r -fo xb.res xb.rc
                cvtres -i386 xb.res -o xb.rbj

xexcept.obj:    xexcept.c
                $(CC) -c -W3 -D_X86_=1 -DWIN32 -D_WIN32 -D_DLL -D_MD /Fa /Zl xexcept.c
#                $(CC) -c -W3 -D_X86_=1 -DWIN32 /Fa xexcept.c

$(LIBDIR)\xstart.o: $(LIBDIR)\xstart.s
                    $(SPASM) $(LIBDIR)\xstart.s

$(LIBDIR)\xlib.o:   $(LIBDIR)\xlib.s
                    $(SPASM) $(LIBDIR)\xlib.s

$(LIBDIR)\xzzz.o:   $(LIBDIR)\xzzz.s
                    $(SPASM) $(LIBDIR)\xzzz.s

xbasic.o:       xbasic.s
                $(SPASM) xbasic.s

xit.o:          xit.s
                $(SPASM) xit.s

xcow.o:         xcow.s
                $(SPASM) xcow.s

xdis.o:         xdis.s
                $(SPASM) xdis.s

xst.o:          xst.s
                $(SPASM) xst.s

xin.o:          xin.s
                $(SPASM) xin.s

xcm.o:          xcm.s
                $(SPASM) xcm.s

xma.o:          xma.s
                $(SPASM) xma.s

xgr.o:          xgr.s
                $(SPASM) xgr.s

xui.o:          xui.s
                $(SPASM) xui.s

xbasic.s:       xbasic.x
                $(START) xb xbasic.x

xit.s:          xit.x
                $(START) xb xit.x -lib

xcow.s:         xcow.x
                $(START) xb xcow.x -lib

xdis.s:         xdis.x
                $(START) xb xdis.x -lib

xst.s:          xst.x
                $(START) xb xst.x -lib

xin.s:          xin.x
                $(START) xb xin.x -lib

xcm.s:          xcm.x
                $(START) xb xcm.x -lib

xma.s:          xma.x
                $(START) xb xma.x -lib

xgr.s:          xgr.x
                $(START) xb xgr.x -lib

xui.s:          xui.x
                $(START) xb xui.x -lib
